#ifndef _INCLUDE_TITANIUM_CONFIG_H_
#define _INCLUDE_TITANIUM_CONFIG_H_

@TOP@

/* self-identification */
#undef PACKAGE
#undef VERSION

/* the stoptifu library */
#undef USE_STOPTIFU

/* using the MIPSPro C compiler (which doesn't seem to have other identifying markers) */
#undef MIPSPRO_COMPILER

/* Track compiler's use (and misuse) of memory */
#undef DEBUG_MEMORY_USAGE

/* Use conservative garbage collector in compiler */
#undef USE_TC_GC

/* Sglobal inference */
#undef USE_SGLOBAL_INFERENCE

/* Disable GC */
#undef USE_GC_NONE

/* Inline modifier supported at runtime */
#undef USE_RUNTIME_INLINE

/* Functions may be declared "static inline" */
#undef STATIC_INLINE_WORKS

/* Variable sized stack arrays at runtime */
#undef USE_RUNTIME_VARARRAY

/* Types for primitive types in inttypes.h */
#undef USE_RUNTIME_INTTYPES_H

/* MAXPATHLEN is defined in sys/param.h */
#undef USE_RUNTIME_SYS_PARAM_H_MAXPATHLEN

/* PATHSIZE and not MAXPATHLEN is defined in sys/param.h */
#undef USE_RUNTIME_SYS_PARAM_H_PATHSIZE

/* Using the GNU C compiler for the Cray at runtime */
#undef USE_RUNTIME_CRAY_GNU_C

/* Using the Cray T3E C compiler at runtime */
#undef USE_RUNTIME_CRAY_T3E_C

/* Use 64-bit point coordinates (workaround for PR291, see c-types/CtPointInstance.cc)*/
#undef USE_64BIT_POINTS

/* C++ string class has erase() methods */
#undef HAVE_STRING_ERASE

/* C++ queue and stack templates take two type parameters */
#undef HAVE_BINARY_ADAPTORS

/* C++ template specialization syntax */
#undef HAVE_TEMPLATE_SPECIALIZATION

/* C++ string class requires inclusion of <std/bastring.cc> */
#undef HAVE_STD_BASTRING_CC

/* C++ character traits template class is called "char_traits" */
#undef HAVE_CHAR_TRAITS

/* C++ character traits template class can be specialized implicitly */
#undef IMPLICIT_CHAR_TRAITS

/* C++ stream state set using ios::setstate() */
#undef HAVE_IOS_SETSTATE

/* has usleep() */
#undef HAVE_USLEEP

/* has nanosleep() */
#undef HAVE_NANOSLEEP

/* has nsleep() */
#undef HAVE_NSLEEP

/* has sched_yield() */
#undef HAVE_SCHED_YIELD

/* has __builtin_expect */
#undef HAVE_BUILTIN_EXPECT

/* has pthread_setconcurrency() */           
#undef HAVE_PTHREAD_SETCONCURRENCY

/* has fmod() */
#undef HAVE_FMOD

/* has remainder() */
#undef HAVE_REMAINDER

/* has drem() */
#undef HAVE_DREM

/* have working __swab16(), __swab32(), and __swab64() macros */
#undef HAVE_SWABN_MACROS

/* check for a certain broken sstream implementation (early GNU g++ release) */
#undef SSTREAM_BROKEN

/* Define if "long-long-support.h" should be included */
#undef USE_LONG_LONG_SUPPORT_H

/* Define if stat64 contains long longs */
#undef STAT64_CONTAINS_LONG_LONGS

/* Define if you have an enameserver.h file that implements a global endpoint na
ming service */
#undef HAVE_ENAMESERVER_H

@BOTTOM@

#ifdef HAVE_FEATURES_H
/* these get us 64-bit file declarations under several Unixen */
/* they must come before the first include of features.h */
#define _LARGEFILE64_SOURCE 1
#define _LARGEFILE_SOURCE 1
# include <features.h>
#endif

/* special GCC features */
#if ! defined (__GNUC__) && ! defined (__attribute__)
#define __attribute__(flags)
#endif

#endif
