#include "AST.h"
#include "errors.h"


// We should probably relocate Error() and Warning() from
// "aux-parser.cc" into this file instead.


ostream &TreeNode::error() const
{
  return Error( position() );
}


ostream &TreeNode::warning() const
{
  return Warning( position() );
}


ostream &TreeNode::message() const
{
  return Message( position() );
}
