#ifndef _include_bcast_common_h_
#define _include_bcast_common_h_

#include "backend.h"


extern int PERPROC_DEF( BroadcastCycle );


#define CYCLE PERPROC_REF( BroadcastCycle )
#define BUFFER (buffer[ CYCLE ])


#define BROADCAST_BEGIN( type, sender )							\
  static volatile type buffer[ 2 ];							\
  do {											\
    if ((sender) < 0 || (sender) > PROCS) {						\
      fprintf( stderr, "fatal error: cannot broadcast from process %d\n", (sender) );	\
      abort();										\
    }											\
  } while (0)


#endif /* !_include_bcast_common_h_ */
