
// Uses fake templates.  Script replaces V_ARITY with specified.

package ti.domains;

//
// =============================
// Rect Domain List and Iterator
// =============================
//

public class tiRectDomainListV_ARITY {

  public tiRectDomainListV_ARITY() {
    rectDomainListHead = null;
    rectDomainListTail = null;
    numItems = 0;
  }

  public tiRectDomainListV_ARITY(tiRectDomainListV_ARITY dl) {
    rectDomainListHead = null;
    rectDomainListTail = null;
    numItems = 0;
    tiRectDomainListItemV_ARITY item;
    for (item = dl.rectDomainListHead; item != null; item = item.next) {
      append(item.rectDomain);
    }
  }

  public boolean isEmpty() { return (rectDomainListHead == null); }

  public void append(tiRectDomainV_ARITY rd) {
    tiRectDomainListItemV_ARITY newItem;

    newItem = new (tiDomains.region) tiRectDomainListItemV_ARITY();
    newItem.rectDomain = rd;
    newItem.next = null;
    if (rectDomainListHead == null) {
      rectDomainListHead = newItem;
    } else {
      rectDomainListTail.next = newItem;
    }
    rectDomainListTail = newItem;
    numItems++;
  }

  public void append(tiDomainV_ARITY d) {
    for (tiRectDomainListIteratorV_ARITY iter =
	   d.getRectangles().newIterator();
	 !iter.isEnd();
	 iter.advance()) {
      append(iter.dereference());
    }
  }

  public tiRectDomainListIteratorV_ARITY newIterator() {
    return new (tiDomains.region) tiRectDomainListIteratorV_ARITY(rectDomainListHead);
  }

  public tiRectDomainV_ARITY getSingularity() {
    if (rectDomainListHead == rectDomainListTail) {
      if (rectDomainListHead == null) {
	return new tiRectDomainV_ARITY();
      } else {
	return rectDomainListHead.rectDomain;
      }
    } else {
      System.out.println("Runtime: (Internal Error) Attempted to get a singularity from a RectDomain list when none existed.");
      return new tiRectDomainV_ARITY();
    }
  }

  public boolean hasSingularity() {
    return (rectDomainListHead == rectDomainListTail);
  }

  public int getNumItems() {
    return numItems;
  }

  public tiRectDomainListIteratorV_ARITY newIterator(tiRectDomainListIteratorV_ARITY iter) {
    return new (tiDomains.region) tiRectDomainListIteratorV_ARITY(iter);
  }

  private tiRectDomainListItemV_ARITY rectDomainListHead;
  private tiRectDomainListItemV_ARITY rectDomainListTail;
  private int numItems;
}
