#ifndef _GPUTIL_H_
#define _GPUTIL_H_

#include "using-std.h"
#include "minmax.h"

static inline int square(int x) { return x * x; }
/* static inline int abs(int a) { return ((a >= 0) ? a : -a); } */

bool is_all_whitespace(const char *s);
bool is_all_digits(const char *s);
char *trim(char *s);

bool snaffle_from_args(char *s, char *&v, int &argc, char **argv,
		       int limit = -1);
void showargs(int argc, char **argv);
void remove_args(int &argc, char **argv, int start, int end);
void remove_arg(int &argc, char **argv, int n);
void remove_arg0(int argc, char **argv);
char *readline(istream &s, int *n = NULL);
char *read(istream &s, char t, int *n = NULL);
int findlast(char c, char *s, int n = -1);

string no_spaces(const string &s);

#endif // _GPUTIL_H_

