#ifndef _PARAMETER_H_
#define _PARAMETER_H_

int get_parameter(string p, bool nonneg = true);
int get_parameter(string p, string desc, bool nonneg = true);
bool get_bool_parameter(string p, bool d = false);
bool get_bool_parameter(string p, string desc, bool d = false);
int get_parameter_without_prefix(string p, bool nonneg = true);
int get_parameter_without_prefix(string p, string desc, bool nonneg = true);
bool get_bool_parameter_without_prefix(string p, bool d = false);
bool get_bool_parameter_without_prefix(string p, string desc, bool d = false);

string & parameter_description(string p);

void push_parameter_prefix(string s, bool must_be_fresh = false);
string pop_parameter_prefix();
void set_parameter_prefix(string s, bool must_be_fresh = false);
string get_parameter_prefix();

void parameter_warn(string p, string warning);
void parameter_error(string error, bool fatal = true);

void parameter_parse_args(int &argc, char **argv);

#endif // _PARAMETER_H_
