package ti.internal;
public class tiDomain {

  // Domain set relationships
  native public tiDomain single op +(tiDomain single d);
  native public tiDomain single op +=(tiDomain single d);
  native public tiDomain single op -(tiDomain single d);
  native public tiDomain single op -=(tiDomain single d);
  native public tiDomain single op *(tiDomain single d);
  native public tiDomain single op *=(tiDomain single d);

  // Domain boolean relationships
  native public boolean single op ==(tiDomain single d);
  native public boolean single op !=(tiDomain single d);
  native public boolean single op <(tiDomain single d);
  native public boolean single op <=(tiDomain single d);
  native public boolean single op >(tiDomain single d);
  native public boolean single op >=(tiDomain single d);

  // RectDomain set relationships
  native public tiDomain single op +(tiRectDomain single d);
  native public tiDomain single op +=(tiRectDomain single d);
  native public tiDomain single op -(tiRectDomain single d);
  native public tiDomain single op -=(tiRectDomain single d);
  native public tiDomain single op *(tiRectDomain single d);
  native public tiDomain single op *=(tiRectDomain single d);

  // RectDomain boolean relationships
  native public boolean single op ==(tiRectDomain single d);
  native public boolean single op !=(tiRectDomain single d);
  native public boolean single op <(tiRectDomain single d);
  native public boolean single op <=(tiRectDomain single d);
  native public boolean single op >(tiRectDomain single d);
  native public boolean single op >=(tiRectDomain single d);

  // Point set relationships
  native public tiDomain single op +(tiPoint single p);
  native public tiDomain single op +=(tiPoint single p);
  native public tiDomain single op -(tiPoint single p);
  native public tiDomain single op -=(tiPoint single p);
  native public tiDomain single op *(tiPoint single p);
  native public tiDomain single op *=(tiPoint single p);
  native public tiDomain single op /(tiPoint single p);
  native public tiDomain single op /=(tiPoint single p);

  // Shape
  native public tiDomain single permute(tiPoint single p);

  // Shape information
  public final static int arity = 0;
  native public int single arity();
  native public tiPoint single lwb();
  native public tiPoint single upb();
  native public tiPoint single min();
  native public tiPoint single max();
  native public int single size();
  native public boolean single contains(tiPoint single p);
  native public tiRectDomain single boundingBox();
  native public boolean single isNull();
  native public boolean single isNotNull();
  native public boolean single isADR();
  native public boolean single isRectangular();
  native public String toString();
  native public tiRectDomain [1d] single RectDomainList();
  native public tiPoint [1d] single PointList();

  native public static tiDomain single toDomain(tiRectDomain single [1d] rd);
  native public static tiDomain toDomain(tiRectDomain [1d] rd);
  native public static tiDomain single toDomain(tiPoint single [1d] p);
  native public static tiDomain toDomain(tiPoint [1d] p);
  protected tiDomain() { }

  // Hack for memory allocation - sets region used for all domain allocations and returns
  // old one. Use null for GCed allocation.
  native public static Region setRegion(Region r);
}
