package ti.lang;

final public class Reduce {
  static private int myproc = Ti.thisProc();
  static private int single procs = Ti.numProcs();



















  public static sglobal int  add (



				int  val, int single to) {
    int  r = add ( val ) ;
    return (myproc == to) ? r : 0 ;
  }


  public static sglobal int  single  add (



				int  val) {
    int  [1d] local a;
    int  [1d] b;

    if (myproc == 0)
      a = new int  [0 : procs - 1];
    b = broadcast (int  [1d]) a from 0;
    b[myproc] = val;
    Ti.barrier();

    if (myproc == 0)
      val = add ( a ) ;





    return (broadcast val from 0);

  }

  public static int  add (



				int  [1d] local a) {
    RectDomain<1> d = a.domain();
    Point<1> start = d.min(), end = d.max(), stride = d.stride();
    int  val = a[start];
    foreach (i in [[start[1] + stride[1]] : end : stride]) {
       val  +=   a[i]  ;



    }
    return val;
  }




















  public static sglobal long  add (



				long  val, int single to) {
    long  r = add ( val ) ;
    return (myproc == to) ? r : 0 ;
  }


  public static sglobal long  single  add (



				long  val) {
    long  [1d] local a;
    long  [1d] b;

    if (myproc == 0)
      a = new long  [0 : procs - 1];
    b = broadcast (long  [1d]) a from 0;
    b[myproc] = val;
    Ti.barrier();

    if (myproc == 0)
      val = add ( a ) ;





    return (broadcast val from 0);

  }

  public static long  add (



				long  [1d] local a) {
    RectDomain<1> d = a.domain();
    Point<1> start = d.min(), end = d.max(), stride = d.stride();
    long  val = a[start];
    foreach (i in [[start[1] + stride[1]] : end : stride]) {
       val  +=   a[i]  ;



    }
    return val;
  }




















  public static sglobal double  add (



				double  val, int single to) {
    double  r = add ( val ) ;
    return (myproc == to) ? r : 0 ;
  }


  public static sglobal double  single  add (



				double  val) {
    double  [1d] local a;
    double  [1d] b;

    if (myproc == 0)
      a = new double  [0 : procs - 1];
    b = broadcast (double  [1d]) a from 0;
    b[myproc] = val;
    Ti.barrier();

    if (myproc == 0)
      val = add ( a ) ;





    return (broadcast val from 0);

  }

  public static double  add (



				double  [1d] local a) {
    RectDomain<1> d = a.domain();
    Point<1> start = d.min(), end = d.max(), stride = d.stride();
    double  val = a[start];
    foreach (i in [[start[1] + stride[1]] : end : stride]) {
       val  +=   a[i]  ;



    }
    return val;
  }



























  public static sglobal int  mult (



				int  val, int single to) {
    int  r = mult ( val ) ;
    return (myproc == to) ? r : 0 ;
  }


  public static sglobal int  single  mult (



				int  val) {
    int  [1d] local a;
    int  [1d] b;

    if (myproc == 0)
      a = new int  [0 : procs - 1];
    b = broadcast (int  [1d]) a from 0;
    b[myproc] = val;
    Ti.barrier();

    if (myproc == 0)
      val = mult ( a ) ;





    return (broadcast val from 0);

  }

  public static int  mult (



				int  [1d] local a) {
    RectDomain<1> d = a.domain();
    Point<1> start = d.min(), end = d.max(), stride = d.stride();
    int  val = a[start];
    foreach (i in [[start[1] + stride[1]] : end : stride]) {
       val  *=   a[i]  ;



    }
    return val;
  }




















  public static sglobal long  mult (



				long  val, int single to) {
    long  r = mult ( val ) ;
    return (myproc == to) ? r : 0 ;
  }


  public static sglobal long  single  mult (



				long  val) {
    long  [1d] local a;
    long  [1d] b;

    if (myproc == 0)
      a = new long  [0 : procs - 1];
    b = broadcast (long  [1d]) a from 0;
    b[myproc] = val;
    Ti.barrier();

    if (myproc == 0)
      val = mult ( a ) ;





    return (broadcast val from 0);

  }

  public static long  mult (



				long  [1d] local a) {
    RectDomain<1> d = a.domain();
    Point<1> start = d.min(), end = d.max(), stride = d.stride();
    long  val = a[start];
    foreach (i in [[start[1] + stride[1]] : end : stride]) {
       val  *=   a[i]  ;



    }
    return val;
  }




















  public static sglobal double  mult (



				double  val, int single to) {
    double  r = mult ( val ) ;
    return (myproc == to) ? r : 0 ;
  }


  public static sglobal double  single  mult (



				double  val) {
    double  [1d] local a;
    double  [1d] b;

    if (myproc == 0)
      a = new double  [0 : procs - 1];
    b = broadcast (double  [1d]) a from 0;
    b[myproc] = val;
    Ti.barrier();

    if (myproc == 0)
      val = mult ( a ) ;





    return (broadcast val from 0);

  }

  public static double  mult (



				double  [1d] local a) {
    RectDomain<1> d = a.domain();
    Point<1> start = d.min(), end = d.max(), stride = d.stride();
    double  val = a[start];
    foreach (i in [[start[1] + stride[1]] : end : stride]) {
       val  *=   a[i]  ;



    }
    return val;
  }



























  public static sglobal int  min (



				int  val, int single to) {
    int  r = min ( val ) ;
    return (myproc == to) ? r : 0 ;
  }


  public static sglobal int  single  min (



				int  val) {
    int  [1d] local a;
    int  [1d] b;

    if (myproc == 0)
      a = new int  [0 : procs - 1];
    b = broadcast (int  [1d]) a from 0;
    b[myproc] = val;
    Ti.barrier();

    if (myproc == 0)
      val = min ( a ) ;





    return (broadcast val from 0);

  }

  public static int  min (



				int  [1d] local a) {
    RectDomain<1> d = a.domain();
    Point<1> start = d.min(), end = d.max(), stride = d.stride();
    int  val = a[start];
    foreach (i in [[start[1] + stride[1]] : end : stride]) {
      if (  a[i]  <  val )  val  =   a[i]  ;



    }
    return val;
  }




















  public static sglobal long  min (



				long  val, int single to) {
    long  r = min ( val ) ;
    return (myproc == to) ? r : 0 ;
  }


  public static sglobal long  single  min (



				long  val) {
    long  [1d] local a;
    long  [1d] b;

    if (myproc == 0)
      a = new long  [0 : procs - 1];
    b = broadcast (long  [1d]) a from 0;
    b[myproc] = val;
    Ti.barrier();

    if (myproc == 0)
      val = min ( a ) ;





    return (broadcast val from 0);

  }

  public static long  min (



				long  [1d] local a) {
    RectDomain<1> d = a.domain();
    Point<1> start = d.min(), end = d.max(), stride = d.stride();
    long  val = a[start];
    foreach (i in [[start[1] + stride[1]] : end : stride]) {
      if (  a[i]  <  val )  val  =   a[i]  ;



    }
    return val;
  }




















  public static sglobal double  min (



				double  val, int single to) {
    double  r = min ( val ) ;
    return (myproc == to) ? r : 0 ;
  }


  public static sglobal double  single  min (



				double  val) {
    double  [1d] local a;
    double  [1d] b;

    if (myproc == 0)
      a = new double  [0 : procs - 1];
    b = broadcast (double  [1d]) a from 0;
    b[myproc] = val;
    Ti.barrier();

    if (myproc == 0)
      val = min ( a ) ;





    return (broadcast val from 0);

  }

  public static double  min (



				double  [1d] local a) {
    RectDomain<1> d = a.domain();
    Point<1> start = d.min(), end = d.max(), stride = d.stride();
    double  val = a[start];
    foreach (i in [[start[1] + stride[1]] : end : stride]) {
      if (  a[i]  <  val )  val  =   a[i]  ;



    }
    return val;
  }



























  public static sglobal int  max (



				int  val, int single to) {
    int  r = max ( val ) ;
    return (myproc == to) ? r : 0 ;
  }


  public static sglobal int  single  max (



				int  val) {
    int  [1d] local a;
    int  [1d] b;

    if (myproc == 0)
      a = new int  [0 : procs - 1];
    b = broadcast (int  [1d]) a from 0;
    b[myproc] = val;
    Ti.barrier();

    if (myproc == 0)
      val = max ( a ) ;





    return (broadcast val from 0);

  }

  public static int  max (



				int  [1d] local a) {
    RectDomain<1> d = a.domain();
    Point<1> start = d.min(), end = d.max(), stride = d.stride();
    int  val = a[start];
    foreach (i in [[start[1] + stride[1]] : end : stride]) {
      if (  a[i]  >  val )  val  =   a[i]  ;



    }
    return val;
  }




















  public static sglobal long  max (



				long  val, int single to) {
    long  r = max ( val ) ;
    return (myproc == to) ? r : 0 ;
  }


  public static sglobal long  single  max (



				long  val) {
    long  [1d] local a;
    long  [1d] b;

    if (myproc == 0)
      a = new long  [0 : procs - 1];
    b = broadcast (long  [1d]) a from 0;
    b[myproc] = val;
    Ti.barrier();

    if (myproc == 0)
      val = max ( a ) ;





    return (broadcast val from 0);

  }

  public static long  max (



				long  [1d] local a) {
    RectDomain<1> d = a.domain();
    Point<1> start = d.min(), end = d.max(), stride = d.stride();
    long  val = a[start];
    foreach (i in [[start[1] + stride[1]] : end : stride]) {
      if (  a[i]  >  val )  val  =   a[i]  ;



    }
    return val;
  }




















  public static sglobal double  max (



				double  val, int single to) {
    double  r = max ( val ) ;
    return (myproc == to) ? r : 0 ;
  }


  public static sglobal double  single  max (



				double  val) {
    double  [1d] local a;
    double  [1d] b;

    if (myproc == 0)
      a = new double  [0 : procs - 1];
    b = broadcast (double  [1d]) a from 0;
    b[myproc] = val;
    Ti.barrier();

    if (myproc == 0)
      val = max ( a ) ;





    return (broadcast val from 0);

  }

  public static double  max (



				double  [1d] local a) {
    RectDomain<1> d = a.domain();
    Point<1> start = d.min(), end = d.max(), stride = d.stride();
    double  val = a[start];
    foreach (i in [[start[1] + stride[1]] : end : stride]) {
      if (  a[i]  >  val )  val  =   a[i]  ;



    }
    return val;
  }





























  public static sglobal int  or (



				int  val, int single to) {
    int  r = or ( val ) ;
    return (myproc == to) ? r : 0 ;
  }


  public static sglobal int  single  or (



				int  val) {
    int  [1d] local a;
    int  [1d] b;

    if (myproc == 0)
      a = new int  [0 : procs - 1];
    b = broadcast (int  [1d]) a from 0;
    b[myproc] = val;
    Ti.barrier();

    if (myproc == 0)
      val = or ( a ) ;





    return (broadcast val from 0);

  }

  public static int  or (



				int  [1d] local a) {
    RectDomain<1> d = a.domain();
    Point<1> start = d.min(), end = d.max(), stride = d.stride();
    int  val = a[start];
    foreach (i in [[start[1] + stride[1]] : end : stride]) {
       val  |=   a[i]  ;



    }
    return val;
  }




















  public static sglobal long  or (



				long  val, int single to) {
    long  r = or ( val ) ;
    return (myproc == to) ? r : 0 ;
  }


  public static sglobal long  single  or (



				long  val) {
    long  [1d] local a;
    long  [1d] b;

    if (myproc == 0)
      a = new long  [0 : procs - 1];
    b = broadcast (long  [1d]) a from 0;
    b[myproc] = val;
    Ti.barrier();

    if (myproc == 0)
      val = or ( a ) ;





    return (broadcast val from 0);

  }

  public static long  or (



				long  [1d] local a) {
    RectDomain<1> d = a.domain();
    Point<1> start = d.min(), end = d.max(), stride = d.stride();
    long  val = a[start];
    foreach (i in [[start[1] + stride[1]] : end : stride]) {
       val  |=   a[i]  ;



    }
    return val;
  }























  public static sglobal boolean  or (



				boolean  val, int single to) {
    boolean  r = or ( val ) ;
    return (myproc == to) ? r : false ;
  }


  public static sglobal boolean  single  or (



				boolean  val) {
    boolean  [1d] local a;
    boolean  [1d] b;

    if (myproc == 0)
      a = new boolean  [0 : procs - 1];
    b = broadcast (boolean  [1d]) a from 0;
    b[myproc] = val;
    Ti.barrier();

    if (myproc == 0)
      val = or ( a ) ;





    return (broadcast val from 0);

  }

  public static boolean  or (



				boolean  [1d] local a) {
    RectDomain<1> d = a.domain();
    Point<1> start = d.min(), end = d.max(), stride = d.stride();
    boolean  val = a[start];
    foreach (i in [[start[1] + stride[1]] : end : stride]) {
       val  |=   a[i]  ;



    }
    return val;
  }





























  public static sglobal int  xor (



				int  val, int single to) {
    int  r = xor ( val ) ;
    return (myproc == to) ? r : 0 ;
  }


  public static sglobal int  single  xor (



				int  val) {
    int  [1d] local a;
    int  [1d] b;

    if (myproc == 0)
      a = new int  [0 : procs - 1];
    b = broadcast (int  [1d]) a from 0;
    b[myproc] = val;
    Ti.barrier();

    if (myproc == 0)
      val = xor ( a ) ;





    return (broadcast val from 0);

  }

  public static int  xor (



				int  [1d] local a) {
    RectDomain<1> d = a.domain();
    Point<1> start = d.min(), end = d.max(), stride = d.stride();
    int  val = a[start];
    foreach (i in [[start[1] + stride[1]] : end : stride]) {
       val  ^=   a[i]  ;



    }
    return val;
  }




















  public static sglobal long  xor (



				long  val, int single to) {
    long  r = xor ( val ) ;
    return (myproc == to) ? r : 0 ;
  }


  public static sglobal long  single  xor (



				long  val) {
    long  [1d] local a;
    long  [1d] b;

    if (myproc == 0)
      a = new long  [0 : procs - 1];
    b = broadcast (long  [1d]) a from 0;
    b[myproc] = val;
    Ti.barrier();

    if (myproc == 0)
      val = xor ( a ) ;





    return (broadcast val from 0);

  }

  public static long  xor (



				long  [1d] local a) {
    RectDomain<1> d = a.domain();
    Point<1> start = d.min(), end = d.max(), stride = d.stride();
    long  val = a[start];
    foreach (i in [[start[1] + stride[1]] : end : stride]) {
       val  ^=   a[i]  ;



    }
    return val;
  }























  public static sglobal boolean  xor (



				boolean  val, int single to) {
    boolean  r = xor ( val ) ;
    return (myproc == to) ? r : false ;
  }


  public static sglobal boolean  single  xor (



				boolean  val) {
    boolean  [1d] local a;
    boolean  [1d] b;

    if (myproc == 0)
      a = new boolean  [0 : procs - 1];
    b = broadcast (boolean  [1d]) a from 0;
    b[myproc] = val;
    Ti.barrier();

    if (myproc == 0)
      val = xor ( a ) ;





    return (broadcast val from 0);

  }

  public static boolean  xor (



				boolean  [1d] local a) {
    RectDomain<1> d = a.domain();
    Point<1> start = d.min(), end = d.max(), stride = d.stride();
    boolean  val = a[start];
    foreach (i in [[start[1] + stride[1]] : end : stride]) {
       val  ^=   a[i]  ;



    }
    return val;
  }





























  public static sglobal int  and (



				int  val, int single to) {
    int  r = and ( val ) ;
    return (myproc == to) ? r : 0 ;
  }


  public static sglobal int  single  and (



				int  val) {
    int  [1d] local a;
    int  [1d] b;

    if (myproc == 0)
      a = new int  [0 : procs - 1];
    b = broadcast (int  [1d]) a from 0;
    b[myproc] = val;
    Ti.barrier();

    if (myproc == 0)
      val = and ( a ) ;





    return (broadcast val from 0);

  }

  public static int  and (



				int  [1d] local a) {
    RectDomain<1> d = a.domain();
    Point<1> start = d.min(), end = d.max(), stride = d.stride();
    int  val = a[start];
    foreach (i in [[start[1] + stride[1]] : end : stride]) {
       val  &=   a[i]  ;



    }
    return val;
  }




















  public static sglobal long  and (



				long  val, int single to) {
    long  r = and ( val ) ;
    return (myproc == to) ? r : 0 ;
  }


  public static sglobal long  single  and (



				long  val) {
    long  [1d] local a;
    long  [1d] b;

    if (myproc == 0)
      a = new long  [0 : procs - 1];
    b = broadcast (long  [1d]) a from 0;
    b[myproc] = val;
    Ti.barrier();

    if (myproc == 0)
      val = and ( a ) ;





    return (broadcast val from 0);

  }

  public static long  and (



				long  [1d] local a) {
    RectDomain<1> d = a.domain();
    Point<1> start = d.min(), end = d.max(), stride = d.stride();
    long  val = a[start];
    foreach (i in [[start[1] + stride[1]] : end : stride]) {
       val  &=   a[i]  ;



    }
    return val;
  }























  public static sglobal boolean  and (



				boolean  val, int single to) {
    boolean  r = and ( val ) ;
    return (myproc == to) ? r : false ;
  }


  public static sglobal boolean  single  and (



				boolean  val) {
    boolean  [1d] local a;
    boolean  [1d] b;

    if (myproc == 0)
      a = new boolean  [0 : procs - 1];
    b = broadcast (boolean  [1d]) a from 0;
    b[myproc] = val;
    Ti.barrier();

    if (myproc == 0)
      val = and ( a ) ;





    return (broadcast val from 0);

  }

  public static boolean  and (



				boolean  [1d] local a) {
    RectDomain<1> d = a.domain();
    Point<1> start = d.min(), end = d.max(), stride = d.stride();
    boolean  val = a[start];
    foreach (i in [[start[1] + stride[1]] : end : stride]) {
       val  &=   a[i]  ;



    }
    return val;
  }











   




















  public static sglobal int  gen (

				IntOp  Oper,

				int  val, int single to) {
    int  r = gen (Oper,  val ) ;
    return (myproc == to) ? r : 0 ;
  }


  public static sglobal int  single  gen (

				IntOp  Oper,

				int  val) {
    int  [1d] local a;
    int  [1d] b;

    if (myproc == 0)
      a = new int  [0 : procs - 1];
    b = broadcast (int  [1d]) a from 0;
    b[myproc] = val;
    Ti.barrier();

    if (myproc == 0)
      val = gen (Oper,  a ) ;





    return (broadcast val from 0);

  }

  public static int  gen (

				IntOp  Oper,

				int  [1d] local a) {
    RectDomain<1> d = a.domain();
    Point<1> start = d.min(), end = d.max(), stride = d.stride();
    int  val = a[start];
    foreach (i in [[start[1] + stride[1]] : end : stride]) {
       val  = Oper.eval( val ,   a[i] ) ;



    }
    return val;
  }






















  public static sglobal long  gen (

				LongOp  Oper,

				long  val, int single to) {
    long  r = gen (Oper,  val ) ;
    return (myproc == to) ? r : 0 ;
  }


  public static sglobal long  single  gen (

				LongOp  Oper,

				long  val) {
    long  [1d] local a;
    long  [1d] b;

    if (myproc == 0)
      a = new long  [0 : procs - 1];
    b = broadcast (long  [1d]) a from 0;
    b[myproc] = val;
    Ti.barrier();

    if (myproc == 0)
      val = gen (Oper,  a ) ;





    return (broadcast val from 0);

  }

  public static long  gen (

				LongOp  Oper,

				long  [1d] local a) {
    RectDomain<1> d = a.domain();
    Point<1> start = d.min(), end = d.max(), stride = d.stride();
    long  val = a[start];
    foreach (i in [[start[1] + stride[1]] : end : stride]) {
       val  = Oper.eval( val ,   a[i] ) ;



    }
    return val;
  }






















  public static sglobal double  gen (

				DoubleOp  Oper,

				double  val, int single to) {
    double  r = gen (Oper,  val ) ;
    return (myproc == to) ? r : 0 ;
  }


  public static sglobal double  single  gen (

				DoubleOp  Oper,

				double  val) {
    double  [1d] local a;
    double  [1d] b;

    if (myproc == 0)
      a = new double  [0 : procs - 1];
    b = broadcast (double  [1d]) a from 0;
    b[myproc] = val;
    Ti.barrier();

    if (myproc == 0)
      val = gen (Oper,  a ) ;





    return (broadcast val from 0);

  }

  public static double  gen (

				DoubleOp  Oper,

				double  [1d] local a) {
    RectDomain<1> d = a.domain();
    Point<1> start = d.min(), end = d.max(), stride = d.stride();
    double  val = a[start];
    foreach (i in [[start[1] + stride[1]] : end : stride]) {
       val  = Oper.eval( val ,   a[i] ) ;



    }
    return val;
  }



























  public static sglobal Object  gen (

				ObjectOp  Oper,

				Object  val, int single to) {
    Object  r = gen (Oper,  val ) ;
    return (myproc == to) ? r : null ;
  }


  public static sglobal Object    gen (

				ObjectOp  Oper,

				Object  val) {
    Object  [1d] local a;
    Object  [1d] b;

    if (myproc == 0)
      a = new Object  [0 : procs - 1];
    b = broadcast (Object  [1d]) a from 0;
    b[myproc] = val;
    Ti.barrier();

    if (myproc == 0)
      val = gen (Oper,  a ) ;





    return (broadcast val from 0);

  }

  public static Object  gen (

				ObjectOp  Oper,

				Object  [1d] local a) {
    RectDomain<1> d = a.domain();
    Point<1> start = d.min(), end = d.max(), stride = d.stride();
    Object  val = a[start];
    foreach (i in [[start[1] + stride[1]] : end : stride]) {
       val  = Oper.eval( val ,   a[i] ) ;



    }
    return val;
  }









}
