#ifndef _TC_GCSET_H_
#define _TC_GCSET_H_

#include <set>

#define generic template <class T>

generic class gcset : public gc {
 public:
  set<T> s;

  void insert(const T & x) { s.insert(x); }
  bool contains(const T & x) const { return s.find(x) != s.end(); }
  bool empty() const { return s.empty(); }
  set<T>::size_type size() const { return s.size(); }
  set<T>::size_type count(const T & x) const { return s.count(x); }
  set<T>::iterator find(const T & x) const { return s.find(x); }

  set<T>::const_iterator begin() const { return s.begin(); }
  set<T>::iterator begin() { return s.begin(); }
  set<T>::const_iterator end() const { return s.end(); }
  set<T>::iterator end() { return s.end(); }

  set<T>::const_iterator rbegin() const { return s.rbegin(); }
  set<T>::iterator rbegin() { return s.rbegin(); }
  set<T>::const_iterator rend() const { return s.rend(); }
  set<T>::iterator rend() { return s.rend(); }
};

#undef generic

#endif
