#ifndef _MINMAX_H_
#define _MINMAX_H_

static inline int max(int a, int b) { return (a > b) ? a : b; }
static inline int min(int a, int b) { return (a < b) ? a : b; }
static inline int max3(int a, int b, int c) { return max(a, max(b, c)); }
static inline int min3(int a, int b, int c) { return min(a, min(b, c)); }
static inline int max4(int a, int b, int c, int d) {
  return max(max(a, b), max(c, d));
}
static inline int min4(int a, int b, int c, int d) {
  return min(min(a, b), min(c, d));
}

#endif // _MINMAX_H_
