#ifndef _include_comm_h_
#define _include_comm_h_


#define ti_write_sync() tic_write_sync()
#define ti_read_sync()  tic_read_sync()
#define ti_sync()       tic_sync()

#define ti_bulk_read(d_addr, s_proc, s_addr, size) \
  bulk_read(d_addr, toglobal(s_proc, s_addr), size, tic_has_ptrs)
#define ti_bulk_read_noptrs(d_addr, s_proc, s_addr, size) \
  bulk_read(d_addr, toglobal(s_proc, s_addr), size, tic_no_ptrs)
#define ti_bulk_write_weak(d_proc, d_addr, s_addr, size) \
  bulk_put(toglobal(d_proc, d_addr), s_addr, size)
#define ti_bulk_write(d_proc, d_addr, s_addr, size) \
  bulk_write(toglobal(d_proc, d_addr), s_addr, size)


#endif /* _include_comm_h_ */
